﻿var gulp = require('gulp');
var concat = require('gulp-concat');
var modifyCssUrl = require('gulp-modify-css-urls');
var base64 = require('gulp-base64');
var minifyCss = require('gulp-minify-css');

gulp.task('vendor-build-styles', function () {
    var styles = [
        './node_modules/bootstrap/dist/css/bootstrap.min.css',
        './node_modules/syncfusion-javascript/Content/ej/web/ej.widgets.core.min.css',
        './node_modules/syncfusion-javascript/Content/ej/web/default-theme/ej.theme.min.css'
    ];

    return gulp.src(styles)
        .pipe(modifyCssUrl({
            modify: function (url, filePath) {
                var removeQueryString = function (p) {
                    var pArr = p.split("?");

                    return pArr[0];
                };
                var removeHashString = function (p) {
                    var pArr = p.split("#");

                    return pArr[0];
                };

                var actualPath = url;

                actualPath = removeQueryString(actualPath);
                actualPath = removeHashString(actualPath);

                return actualPath;
            }
        }))
        .pipe(base64({
            debug: true,
            maxImageSize: 10000 * 1024
        }))
        .pipe(concat('vendor.css'))
        .pipe(minifyCss())
        .pipe(gulp.dest('./Web/a24_/EventManAppConfig/css'));
});

gulp.task('vendor-build-scripts', function () {
    var scripts = [
        './node_modules/jquery/dist/jquery.min.js',
        './node_modules/knockout/build/output/knockout-latest.js',
        './node_modules/bootstrap/dist/js/bootstrap.min.js',
        './node_modules/q/q.js',
        './node_modules/i18next/i18next.min.js',
        './node_modules/urijs/src/URI.min.js',
        './node_modules/jsrender/jsrender.min.js',
        // Syncfusion external
        // Syncfusion scripts - common
        './node_modules/syncfusion-javascript/Scripts/ej/common/ej.core.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/common/ej.data.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/common/ej.draggable.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/common/ej.globalize.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/common/ej.scroller.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/common/ej.touch.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/common/ej.unobtrusive.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/common/ej.webform.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/common/ej.widget.ko.min.js',
        // Syncfusion scripts - web
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.toolbar.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.dialog.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.datepicker.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.timepicker.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.datetimepicker.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.checkbox.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.dropdownlist.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.editor.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.maskedit.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.autocomplete.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.pager.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.button.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.togglebutton.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.splitbutton.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.waitingpopup.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.menu.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.radiobutton.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.excelfilter.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.grid.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.rte.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.uploadbox.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.tooltip.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.tab.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.slider.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.treeview.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.splitter.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.colorpicker.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.fileexplorer.min.js',
        './node_modules/syncfusion-javascript/Scripts/ej/web/ej.listbox.min.js',
               
        // Syncfusion scripts - cultures
        //'./bower_components/syncfusion-ej-global/i18n/ej.culture.en-US.js',
        //'./bower_components/syncfusion-ej-global/i18n/ej.culture.de-DE.js',
        // Syncfusion scripts - locale texts
        //'./bower_components/syncfusion-ej-global/l10n/ej.localetexts.en-US.js',
        //'./bower_components/syncfusion-ej-global/l10n/ej.localetexts.de-DE.js'
    ];

    return gulp.src(scripts)
        .pipe(concat('vendor.js'))
        .pipe(gulp.dest('./Web/a24_/EventManAppConfig/js'));
});

gulp.task('vendor', ['vendor-build-scripts', 'vendor-build-styles'], function () {
    console.log("Vendor - Success!");
});

// Default task
gulp.task('default', function () {
    console.log("Gulp - Default task!");
});